#pragma once

#include <memory>

#include <dune/istl/preconditioners.hh>

namespace AMDiS
{
  template <class Mat, class Sol, class Rhs>
  struct ISTLPreconCreatorInterface
  {
    virtual ~ISTLPreconCreatorInterface() = default;

    using PreconBase = Dune::Preconditioner<Sol, Rhs>;
    virtual std::unique_ptr<PreconBase> create(Mat const& matrix) const = 0;
  };

} // end namespace AMDiS